package uap.bs.bap.fs.server;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.framework.common.NCLocator;
import nc.vo.pub.lang.UFDateTime;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.multipart.MultipartException;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.multipart.MultipartResolver;
import org.springframework.web.multipart.commons.CommonsMultipartResolver;

import uap.bs.bap.fs.service.IFileMetaStorageService;
import uap.bs.bap.fs.storage.DiskFileStoreHandler;
import uap.bs.bap.fs.storage.IFileStorageHandler;
import uap.pub.bap.fs.FileStorageUtil;
import uap.pub.bap.fs.domain.FileHeader;
import uap.pub.bap.fs.domain.FileStorageException;
import uap.pub.bap.fs.domain.IFileStorageConst;
import uap.pub.bap.fs.domain.ext.BaFileStoreExt;
import uap.pub.bap.fs.domain.ext.FileStorageExtPackage;

import com.ufida.iufo.pub.tools.AppDebug;
import com.ufida.zior.perfwatch.PerfWatch;

/**
 * ļ䣨ϴأservlet
 * 
 * @author chenfeic
 * 
 */

@SuppressWarnings("serial")
public class FileTransferRESTService extends FileStorageRESTService {

	private static final String SPLITER = "||";
	
	private static final String INNER_SPLITER = "$";

	private static MultipartResolver multipartResolver = new CommonsMultipartResolver();;

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws IOException, ServletException {
//		PerfWatch pw = new PerfWatch("ϴļservlet FileTransferRESTService.doGet()");//ܻУ˹ܹܲ
		DateFormat dateFormat = DateFormat.getDateTimeInstance();
//		pw.appendMessage("ʱΪ " + dateFormat.format(new Date()));
		try {
			DiskFileStoreHandler handler = new DiskFileStoreHandler();
			String moduleId = getModuleId(req);
			String strBill = req.getParameter(IFileStorageConst.PAR_ISBILL);
			boolean isBill = Boolean.valueOf(strBill);
//			pw.appendMessage("ģţ" + moduleId);
			if (isBill) {
				String billItem = req
						.getParameter(IFileStorageConst.PAR_BILLITEM);
				if (!StringUtils.isEmpty(billItem)) {
					FileHeader header = getHeaderByBill(handler, moduleId,
							billItem);
					//  MINEٴ
					if (header != null) {
						addFileName(req, resp, false, header);
//						pw.appendMessage("ļPK:" + header.getPath());
					}
					downloadByBill(resp, handler, header);
				}
			} else {
				String strView = req.getParameter(IFileStorageConst.PAR_ISVIEW);
				boolean isView = Boolean.valueOf(strView);
				// MINE
				String filePath = getFileIdByURI(req);
				FileHeader fileHeader = handler.getDaoService()
						.getFileHeaderByPath(moduleId, filePath);
				if (fileHeader != null) {
					addFileName(req, resp, isView, fileHeader);
				}
//				pw.appendMessage("ļPK:" + filePath);
				super.doGet(req, resp);
			}
		} catch (Exception e) {
			AppDebug.error("ļ" + e);
//			pw.appendMessage(e);
			throw new FileStorageException("Download file error! "
					+ e.getMessage());
		} finally {
//			pw.stop();
		}

	}

	private void addFileName(HttpServletRequest req, HttpServletResponse resp,
			boolean isView, FileHeader fileHeader)
			throws UnsupportedEncodingException {
		if (StringUtils.isBlank(req.getHeader("Content-Disposition"))) {
			String contentType = FileTypeHelper.getContentType(fileHeader
					.getFileType());
			if (StringUtils.isEmpty(contentType))
				contentType = "application/zip";
			String fileName = null;
			fileName = fileHeader.getFileName() + "."
					+ fileHeader.getFileType();
			fileName = new String(fileName.getBytes(), "ISO-8859-1");
			resp.setContentType(contentType);
			if (!contentType.equals("application/pdf") || !isView) {
				resp.addHeader("Content-Disposition", (isView ? contentType
						: "attachment" + ";filename=" + fileName));
			}
		}
	}

	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws IOException {
		String path = getModulePath(req);
		if (!path.startsWith(PATH_FILES)) {
			resp.sendError(HttpServletResponse.SC_FORBIDDEN);
			return;
		}
//		PerfWatch pw = new PerfWatch("ϴļservlet FileTransferRESTService.doPost()");
		DateFormat dateFormat = DateFormat.getDateTimeInstance();
//		pw.appendMessage("ϴʱΪ " + dateFormat.format(new Date()));

		if("querymetas".equals(req.getParameter("oper"))){
			queryMetas(req, resp);
			return;
		}
		
		InputStream input = null;
		// ObjectOutputStream oos = null;
		resp.setCharacterEncoding("utf-8");
		PrintWriter out = resp.getWriter();
		try {
			DiskFileStoreHandler handler = new DiskFileStoreHandler();
			String moduleId = getModuleId(req);
			MultipartHttpServletRequest request = getMultipartResolver(req);
			Map<String, MultipartFile> fileMap = request.getFileMap();
			List<MultipartFile> files = new ArrayList<MultipartFile>();
			if (MapUtils.isNotEmpty(fileMap)) {
				files.addAll(fileMap.values());
			} else {
				throw new FileStorageException("The file is NULL");
			}
			String billType = request
					.getParameter(IFileStorageConst.PAR_BILLTYPE);
			String billItem = request
					.getParameter(IFileStorageConst.PAR_BILLITEM);
			String iscover = request
					.getParameter(IFileStorageConst.PAR_ISCOVER);
			String filepk = request.getParameter(IFileStorageConst.PAR_FILEPK);
			if (StringUtils.isEmpty(moduleId)) {
				moduleId = request.getParameter(IFileStorageConst.PARA_MODULE);
			}
			String currUser = request
					.getParameter(IFileStorageConst.ATTRIBUTE_CURR_USER);

			FileHeader fileHeader = null;
			if (!StringUtils.isEmpty(filepk)) {
				fileHeader = handler.getDaoService().getFileHeaderByPath(
						moduleId, filepk);
			}

			boolean override = iscover != null
					&& Boolean.TRUE.toString().equals(iscover);

			MultipartFile file = (MultipartFile) files.get(0);
			String fileName = file.getOriginalFilename();
			input = file.getInputStream();
//			pw.appendMessage("ϴΪ" + FileStorageUtil.getCurrentUser(currUser));
			
			String packageInfos = request.getParameter("packages");
			 
			if (fileHeader != null) {
				// fileHeader.setFileSize((file.getSize()));
				// fileHeader.setName(fileName);
				// handler.getFileHeaderDao().updateFileHeader(fileHeader);//Ԫ
				if (!StringUtils.isEmpty(fileName)
						&& !fileName.equals(fileHeader.getName())) {
					handler.renameFile(moduleId, filepk, fileName, currUser);// ļ
				}
				handler.updateFile(moduleId, filepk, currUser, input);// ļ
//				pw.appendMessage("ļ");
//				pw.appendMessage("ģΪ" + moduleId);
//				pw.appendMessage("ļPKΪ" + filepk);
			}else if(packageInfos != null){
            	FileStorageExtPackage[] extPackage = genExtPackages(packageInfos);
            	fileHeader = handler.writeFile(moduleId, fileName, input, override, currUser, extPackage);
            } else {
				BaFileStoreExt ext = new BaFileStoreExt();
				ext.setPk_billitem(billItem);
				ext.setPk_billtype(billType);
//				pw.appendMessage("ϴļ");
//				pw.appendMessage("ģΪ" + moduleId);
//				pw.appendMessage("ļΪ" + fileName);
				fileHeader = handler.writeFile(moduleId, fileName, input,
						override, currUser, ext);
//				pw.appendMessage("ļPKΪ" + fileHeader.getPath());
			}

			String[] rtn = new String[] { fileHeader.getPath(), fileName,
					Long.valueOf(file.getSize()).toString(),
					FileStorageUtil.getFileType(fileName),
					new UFDateTime().toString(),
					FileStorageUtil.getCurrentUser(currUser), null };
			String join = StringUtils.join(rtn, SPLITER);

			// oos = new ObjectOutputStream(resp.getOutputStream());
			// oos.writeObject(join);
			//
			// if (oos != null) {
			// oos.flush();
			// }

			out.append(join);
			out.flush();

			resp.setStatus(HttpServletResponse.SC_OK);
		} catch (Exception e) {
			AppDebug.error("" + e);
//			pw.appendMessage(e);
			throw new FileStorageException("upload file error:"
					+ e.getMessage());
		} finally {
			closeInputStream(input);
			out.close();
//			pw.stop();
		}
	}
	
	private void queryMetas(HttpServletRequest req, HttpServletResponse resp){
		resp.setCharacterEncoding("utf-8");
   	 PrintWriter out = null;
		try {
			out = resp.getWriter();
			HttpServletRequest request = req;

			String pkStr = request.getParameter("pks");
			String[] pks = StringUtils.split(pkStr, ",");

			IFileMetaStorageService daoService = NCLocator.getInstance().lookup(
					IFileMetaStorageService.class);
			FileHeader[] headers;
			try {
				headers = daoService.getAllHeaders(pks);
			} catch (Exception e) {
				AppDebug.error("Query Headers error:");
				throw new FileStorageException("Query Headers error:"
						+ e.getMessage());
			}
			
			int totalSize = headers.length;
			out.write("totalSize=" + totalSize);
			for (int i = 0; i < headers.length; i++) {
				if(i == 0){
					out.write(SPLITER);
				}
				String str = genRespStr(headers[i]);
				out.write(str);
				if(i != headers.length -1){
					out.write(SPLITER);
				}
			}
			out.flush();
		} catch (IOException e) {
			AppDebug.debug(e.getMessage());
		}finally{
	         out.close();
		}
   }

	private String genRespStr(FileHeader header){
		String[] strs = new String[]{header.getModule(),header.getPath(),header.getName(),header.getCreator(),
				header.getCreatetime() != null ? header.getCreatetime().toStdString() : null,
				header.getLastModifier(),header.getLastModifytime() != null ? header.getLastModifytime().toStdString() : null,
				String.valueOf(header.getFileSize())};
    	
    	return StringUtils.join(strs, INNER_SPLITER);
    }
    
	private FileStorageExtPackage[] genExtPackages(String packageInfos) {
		List<FileStorageExtPackage> packageList = new ArrayList<FileStorageExtPackage>();
		String[] packages = StringUtils.split(packageInfos, SPLITER);
		for (String extPackage : packages) {
			FileStorageExtPackage extPac = new FileStorageExtPackage();
			String[] pacItems = StringUtils.split(extPackage, "$");
			extPac.setExtClassNmae(pacItems[0]);
			extPac.setTableName(pacItems[1]);
			extPac.setColumnsName(pacItems[3].split(","));
			extPac.setColumnsType(pacItems[4].split(","));
			extPac.setColumnsValue(pacItems[5].split(","));
			packageList.add(extPac);
		}
		return packageList
				.toArray(new FileStorageExtPackage[packageList.size()]);
	}
	   
	private FileHeader getHeaderByBill(IFileStorageHandler handler,
			String moduleId, String billItem) {
		BaFileStoreExt ext = new BaFileStoreExt();
		ext.setPk_billitem(billItem);
		FileHeader fileHeader = null;
		FileHeader[] fileHeaders = handler.queryHeaders(moduleId, ext);
		if (ArrayUtils.isEmpty(fileHeaders)) {
			return null;
		} else {
			fileHeader = fileHeaders[0];
		}
		return fileHeader;
	}

	private void downloadByBill(HttpServletResponse resp,
			IFileStorageHandler handler, FileHeader fileHeader) {
		if (fileHeader == null) {
			return;
		}
		String filePath = fileHeader.getPath();
		InputStream in = handler.readFile(fileHeader.getModule(),
				fileHeader.getPath());
		if (in == null) {// յļ
			return;
		}
		ServletOutputStream outputStream = null;
		try {
			outputStream = resp.getOutputStream();
			byte[] buf = new byte[1024];
			int len = -1;
			while ((len = in.read(buf)) != -1) {
				outputStream.write(buf, 0, len);
			}
			if (outputStream != null) {
				outputStream.flush();
			}
		} catch (IOException e) {
			AppDebug.error("GET" + e);
			throw new FileStorageException("Get request error:"
					+ e.getMessage());
		} finally {
			closeOutputStream(outputStream);
			closeInputStream(in);
		}

	}

	private String getModuleId(HttpServletRequest req) {
		String path = getRelativePath(req);
		int index = path.indexOf(PATH_FILES);
		if (index == 0) {
			throw new FileStorageException(nc.vo.ml.NCLangRes4VoTransl
					.getNCLangRes().getStrByID("8001006_0", "08001006-0325")/*
																			 * @res
																			 * "ģΪ"
																			 */);
		}
		String module = path.substring(1, index);
		if (IFileStorageConst.DEFAULT_MODULE.equals(module)) {
			module = "";
		}
		return module;
	}

	/**
	 * ȡļPKfilePath---getʽ
	 * 
	 * @param req
	 * @return
	 */
	protected String getFileIdByURI(HttpServletRequest req) {
		String path = getRelativePath(req);
		int index = path.indexOf(PATH_FILES);
		String noModelPath = path.substring(index);// ģŵ·
		String fileId = null;// ļ߼·
		int filePos = noModelPath.substring(1).indexOf("/");
		if (filePos != -1) {
			fileId = noModelPath.substring(filePos + 2); // ͨuriֱӵõ·
		}
		return fileId;
	}

	private static MultipartHttpServletRequest getMultipartResolver(
			HttpServletRequest request) throws MultipartException {

		((CommonsMultipartResolver) multipartResolver)
				.setDefaultEncoding("UTF-8");

		return multipartResolver.resolveMultipart(request);
	}

}
