package uap.pub.bap.fs.domain.ext;

import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

import com.ufida.iufo.pub.tools.AppDebug;

import uap.pub.bap.fs.domain.FileStorageException;

/**
 * @author jinfeng
 */
public class FileStorageMappingVO {
    /**
     * @param extVoչԶ
     * @param columnsչֶ
     * @return column value in db
     */
    public Object[] getExtColumnValue(IFileStorageExt extVo, String[] columns) {
        Object[] columnsValue = new Object[columns.length];
        try {
            for (int i = 0; i < columns.length; i++) {
                // õԵֵ
                Field field = extVo.getClass().getDeclaredField(columns[i]);
                field.setAccessible(true);
                Object fieldVal = field.get(extVo);
                // Ҫһ
                columnsValue[i] = fieldVal;
            }
        } catch (Exception e) {
        	AppDebug.error("Initial Object failure.");
            throw new FileStorageException("Initial Object failure", e);
        }
        return columnsValue;
    }

    /**
     * @param extPackage
     *        չԵķװ
     * @return չ
     */
    public IFileStorageExt transform2Ext(FileStorageExtPackage extPackage) {
        Object[] columnsValue = extPackage.getColumnsValue();
        String[] columnsName = extPackage.getColumnsName();
        try {
            Class<?> clz = Class.forName(extPackage.getExtClassNmae());
            IFileStorageExt extVO = (IFileStorageExt) clz.newInstance();

            FileStorageMappingMeta meta = new FileStorageMappingMeta(extVO);
            String[] columnsName2 = meta.getAttributes();
            Map<String, String> colCombineName = new HashMap<String, String>();
            for (String colName : columnsName2) {
                colCombineName.put("FLD_" + colName.toUpperCase(), colName);
            }

            for (int i = 0; i < columnsName.length; i++) {
                // õ
                Field field = extVO.getClass().getDeclaredField(colCombineName.get(columnsName[i].toUpperCase()));
                field.setAccessible(true);
                Object value = columnsValue[i];
                if (null != value) {
                    String fieldType = field.getType().getSimpleName();
                    if ("String".equals(fieldType)) {
                        field.set(extVO, (String) value);
                    } else if ("byte".equalsIgnoreCase(fieldType)) {
                        field.set(extVO, (Byte) value);
                    } else if ("Integer".equals(fieldType) || "int".equals(fieldType)) {
                        if (value instanceof Integer)
                            field.set(extVO, ((Integer) value));
                        else
                            field.set(extVO, ((BigDecimal) value).intValue());
                    } else if ("short".equalsIgnoreCase(fieldType)) {
                        Short shortVal = Short.parseShort(value.toString());
                        field.set(extVO, shortVal);
                    } else if ("long".equalsIgnoreCase(fieldType)) {
                        Long longVal = Long.parseLong(value.toString());
                        field.set(extVO, longVal);
                    } else if ("Float".equalsIgnoreCase(fieldType)) {
                        field.set(extVO, (Float) value);
                    } else if ("Double".equalsIgnoreCase(fieldType)) {
                        field.set(extVO, (Double) value);
                    } else if ("Character".equals(fieldType) || "char".equals(fieldType)) {
                        field.set(extVO, (Character) value);
                    } else if ("Boolean".equalsIgnoreCase(fieldType)) {
                        field.set(extVO, (Boolean) value);
                    }
                }
            }
            return extVO;
        } catch (Exception e) {
        	AppDebug.error("Initial Object failure.");
            throw new FileStorageException("Initial Object failure", e);
        }
    }
}
